/**********************************************************
C^[o^C}荞݂ɂĂQ̃^XN̐؂ւs
**********************************************************/
#include <3048f.h>
#include "h8_3048.h"

/***************@Q̃^XN̎́@@********************/
void msecwait(int msec)
/*mescԂȂɂȂԉ҂֐*/
{
	int i,j;
	for (i=0;i<msec;i++) {
		for (j=0;j<1588;j++);    /*1588͎ɂċ߂l*/
	}
}

void task0(void)
{
	int cnt=0;
	while (1) {
		D_INT();  /*̃fł͒ʐM͊荞݋֎~ɂă\[X̋Ă*/
		SCI1_printf("task0 %4d\n",cnt);
		E_INT();
		msecwait(20);
		cnt++;
		if (cnt==100) cnt=0;
	}
}

void task1(void)
{
	int cnt=1000;
	while (1) {
		D_INT();  /*̃fł͒ʐM͊荞݋֎~ɂă\[X̋Ă*/
		SCI1_printf("task1 %4d\n",cnt);
		E_INT();
		msecwait(20);
		cnt++;
		if (cnt==1100) cnt=1000;
	}
}

/***************@Q̃^XN̎́@܂Ł@********************/

typedef union {
	unsigned char Bccr;
	unsigned long int returnAddress;
} stack_t;

typedef struct {
	unsigned long int Ber7;   /*ԂłBer0Ă*/
	unsigned char stack[128]; /*stack`stack0̍킳̂ۂ̃X^bN*/
	unsigned long int Ber0;   /*ԂER0ƍlC̓X^bN̈ꕔ*/
	unsigned long int Ber1;   /*ԂER1ƍlC̓X^bN̈ꕔ*/
	unsigned long int Ber2;   /*ԂER2ƍlC̓X^bN̈ꕔ*/
	unsigned long int Ber3;   /*ԂER3ƍlC̓X^bN̈ꕔ*/
	unsigned long int Ber4;   /*ԂER4ƍlC̓X^bN̈ꕔ*/
	unsigned long int Ber5;   /*ԂER5ƍlC̓X^bN̈ꕔ*/
	unsigned long int Ber6;   /*ԂER6ƍlC̓X^bN̈ꕔ*/
	stack_t stack0;           /*Ԃ͂ɖ߂AhXCCRĂ*/
} context_t;

context_t context0,context1; /*ReLXgobt@̎*/
int tasksw=0; /* 0 ܂ 1 ғ̃^XNԍ*/
unsigned long int systemstackPtr;  /*XCb`pX^bN|C^ޔꏊ*/

/*ReLXgobt@̒̃WX^̕\@mFp*/
void printContext1(context_t *con)
{
	unsigned long int *currentPtr=(unsigned long int *)(con->Ber7);
	SCI1_printf("ER0 %08lx    ",currentPtr[0]);
	SCI1_printf("ER4 %08lx\n",  currentPtr[4]);
	SCI1_printf("ER1 %08lx    ",currentPtr[1]);
	SCI1_printf("ER5 %08lx\n",  currentPtr[5]);
	SCI1_printf("ER2 %08lx    ",currentPtr[2]);
	SCI1_printf("ER6 %08lx\n",  currentPtr[6]);
	SCI1_printf("ER3 %08lx    ",currentPtr[3]);
	SCI1_printf("ER7 %08lx\n",con->Ber7);
}

/*X^bN̂ӂ̕\*/
void printStackArea(context_t *con)
{
	unsigned long int address=(unsigned long int)(&(con->stack0))+4;
	int i;
	SCI1_printf("tail of stack + 1 =%05lx\n",address);
	address-=0x30;
	address&=0xfffffff0;
	SCI1_printf("address +0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F\n");
	for (i=0; i<0x40; i++,address++) {
		if (i%0x10==0) SCI1_printf ("%05lx : ",address);
		SCI1_printf("%02x ",*(unsigned char*)address);
		if (i%0x10==0xf) SCI1_printf("\n");
	}
}

/*ReLXgobt@̃WX^\֐@mFp*/
void printContext(void)
{
	SCI1_printf("  context for task0\n");
	printContext1(&context0);
	printStackArea(&context0);
	SCI1_printf("  context for task1\n");
	printContext1(&context1);
	printStackArea(&context1);
}

unsigned char Bccr;      /*CCR荞*/

main()
{
	initLed();   /*LEDjbg̏@_ł邪CmFp*/
	initSCI1();  /*VAʐM̏*/
	SCI1_printf("\n\n\n  *** task switcher demo ***\n\n");
	initTimer01Int(500); /*Ԋ荞500msec ITUch0,1gp@̃^C~OŃ^XN؂ւN*/
	E_INT();        /*CPU荞݋*/

	/*荞݋CCR̎荞*/
#pragma asm
    STC.b  CCR, R0l
    mov.b  R0l, @_Bccr
#pragma endasm

	/*ReLXgobt@ɃReLXgQ̍쐬*/
	context0.stack0.returnAddress=(unsigned long int)task0;
	context0.stack0.Bccr=Bccr;
	context0.Ber7=(unsigned long int)&context0.Ber0;
	SCI1_printf("task0,Bcc,stack,er7=%p %02x %08lx %08lx\n", task0, Bccr, context0.stack0.returnAddress, context0.Ber7);

	context1.stack0.returnAddress=(unsigned long int)task1;
	context1.stack0.Bccr=Bccr;
	context1.Ber7=(unsigned long int)&context1.Ber0;
	SCI1_printf("task1,Bcc,stack,er7=%p %02x %08lx %08lx\n", task1, Bccr, context1.stack0.returnAddress, context1.Ber7);
	
	printContext();

	startTimer01();  /*Ԋ荞݃^C}X^[gch0,ch1*/

	/*2̃^XN݂ɋNBŏtask0N*/
	tasksw=0;
#pragma asm
    mov.l  er7,  @_systemstackPtr  ;̃X^bN|C^ޔ
    mov.l  @_context0, er7 ;^XN0̃X^bN|C^𕜋A
                           ; context0context0.Ber7͓AhX
    pop.l  er0
    pop.l  er1
    pop.l  er2
    pop.l  er3
    pop.l  er4
    pop.l  er5
    pop.l  er6
    rte                            ;ReTurn from Exception ɂ^XNN
#pragma endasm

} /*end of main*/

/*xNge[u̐ݒ*/
#pragma asm
    .SECTION    MYVEC, DATA, LOCATE=H'000070
    .ORG        H'000070  ;IMIA1
    .DATA.L     _TaskSwitcher
    .SECTION    P,CODE,ALIGN=2 ;YĂ͂Ȃ
#pragma endasm


/*
C^[o^C}荞݂ŋN郋[`C^XN؂ւ̍Ƃs
TaskSwitcherł͎̂Ƃs
iPj݂̃^XNtask0,task1̂ǂło
iQj݂̑SWX^context0C܂context1Ƃĕۑ
iRj̃^XNɂނcontext0C܂context1SWX^ɍڂ
iSjrteŐV^XNNi荞݂߂ӂj
*/
#pragma asm
_TaskSwitcher:                   ; function: TaskSwitcher
    ;^C}jbgɊ荞݂󂯕tƂm点
    BCLR.B #0,@H'FFFF71:8         ;ITU1.TSR.BIT.IMFA=0;

    ; ** ReLXgۑ **
    push.l er6
    push.l er5
    push.l er4
    push.l er3
    push.l er2
    push.l er1
    push.l er0
    mov.w  @_tasksw, r0
    xor.w  #1, r0
    mov.w  r0,  @_tasksw
    beq    L01  ;݂^XNPC^XNOȂWv
    ;O̓^XNÔŃX^bN|C^ReLXgOBer7ɕۑ
    mov.l  er7,  @_context0; context0context0.Ber7͓AhX
    bra L02
L01:
    ;O̓^XNP̂ŃX^bN|C^ReLXgPBer7ɕۑ
    mov.l  er7,  @_context1; context1context1.Ber7͓AhX
L02:

    mov.l  @_systemstackPtr,  er7 ;p̃X^bN̕A
    jsr @_printContext            ;context̃XibvVbgimFpj
    jsr @_blinkLED                ;LED_Ł@i_pjł͉Ă悢Ƃ̌
    mov.l  er7,  @_systemstackPtr ;p̃X^bN̕ۑ

    ; ** VReLXgݒ **
    mov.w  @_tasksw, r0
    xor.w  #1, r0
    beq    L03  ;V^XNPȂWv
    ;ReLXgOBer7X^bN|C^𕜋A
        mov.l  @_context0, er7 ; context0context0.Ber7͓AhX
    bra L04
L03:
    ;ReLXgPBer7X^bN|C^𕜋A
        mov.l  @_context1, er7; context1context1.Ber7͓AhX
L04:
    pop.l  er0
    pop.l  er1
    pop.l  er2
    pop.l  er3
    pop.l  er4
    pop.l  er5
    pop.l  er6

    rte

#pragma endasm

/*̍Ƃ͂܂CC^[o^C}̓삪Ďł*/
void blinkLED()
{
	static int tick=0;
	if (tick==1) {
		turnOnLed(0);
		turnOffLed(1);
	} else {
		turnOffLed(0);
		turnOnLed(1);
	}
	tick=1-tick;
}
